import java.io.*;

public class articleDB extends Object {

/**
  *
  * Die Klasse articleDB stellt 3 Arrays mit 30 Elementen und eine Methode zur Verfgung.
  * Die Arrays Artikelnummer, Artikelbezeichnung und Artikelpreis entsprechen den Feldern
  * Artikelnummer, Bezeichnung, Preis aus der Aufgabenstellung.
  * Die Methode readArticleDB bentigt 2 Argumente: Pfad und Dateinamen der Artikeldatei
  *
  */
	articleDB() {
		// Ein leerer Constructor.
	}
	articleDB(String pfad,String name) {
		// Hier wird das initialisierte Objekt gleich mit Daten gefllt.
		readArticleDB(pfad, name);
	}

	public static int Artikelnummer[] = new int[30];
	public static String Artikelbezeichnung[] = new String[30];
        public static int Artikelpreis[] = new int[30];

	public static void readArticleDB(String pfad,String name){
                int i = 0;
		// Diese Variablen werden fr die Umwandlung des Preis-Strings bentigt
 		int help = 0,decimaldot;
		// record ist eine Zeile der Tabelle, filehandle ist ein Objekt der
		// Klasse ReadFile aus der Angabe; comma1 und comma2 sind die Positionen der Feldtrennzeichen
		String record;
        	ReadFile filehandle;
		int comma1, comma2;

	       	filehandle = new ReadFile(pfad,name);
		System.out.println("Eingelesene Artikelstammdaten: ");
		while (null != (record = filehandle.readLine())) {	// Eine Zeile wird eingelesen, und geprft, ob dort Daten drinstehen
			comma1 = record.indexOf(',');
			comma2 = record.indexOf(',',comma1 + 1 );	// Die Feldtrennzeichen werden bestimmt
			if (comma1 == -1 || comma2 == -1) {
				System.out.println("Falsches Format: " + record);
				continue;
			}
			try {
				Artikelnummer[i] = Integer.parseInt(record.substring(0,comma1));
			} catch (NumberFormatException e){
				System.out.println("Illegales Zeichen in Artikelnummer: " + record.substring(0,comma1));
			}
			// Integer.parseInt wandelt einen String aus Zahlen in einen int um.
			if (Artikelnummer[i] > 999)						// Plausi laut Angabe
				System.out.println("Artikelnummer ist zu gross (> 999): "+Artikelnummer[i]);
			Artikelbezeichnung[i] = record.substring(comma1+1,comma2);
			if (Artikelbezeichnung[i].length() > 20)				// Plausi laut Angabe
				System.out.println("Artikelbezeichnung ist zu lang (> 20): "+Artikelbezeichnung[i]);

			// Die nchsten Zeilen lesen den Float-strin ein, und verpacken ihn in einem Int
			decimaldot = record.substring(comma2+1,record.length()).indexOf('.');
			try {
				help = Integer.parseInt(record.substring(comma2+1+decimaldot + 1,record.length()));
			} catch (NumberFormatException e) {
				System.out.println("Illegales Zeichen in Artikelpreis: " + record.substring(comma2+1,record.length()));
			}
			if (help > 99)								 // Plausi laut Angabe
				System.out.println("Zuviele Nachkommastellen (> 2): " +help);
			try {
				Artikelpreis[i] = ((Integer.parseInt(record.substring(comma2+1,comma2+1+decimaldot)))*100) + help;
				
			} catch (NumberFormatException e){
				System.out.println("Illegales Zeichen in Artikelpreis: " + record.substring(comma2+1,record.length()));
			}
			if (Artikelpreis[i] > 99999) 						//Plausi laut Angabe
				System.out.println("Artikel ist zu teuer ( > 999.99): "+Artikelpreis[i]);
			System.out.println(Artikelnummer[i] + " " + Artikelbezeichnung[i] + " zum Preis von " + Integer.toString(Artikelpreis[i]).substring(0,Integer.toString(Artikelpreis[i]).length() - 2)
				+ "."+Integer.toString(Artikelpreis[i]).substring(Integer.toString(Artikelpreis[i]).length() - 2,Integer.toString(Artikelpreis[i]).length())  + " ATS");
                        i++;
		}

	}
	
	public static void main(String args) {
	}
}