import java.io.*;

public class bill extends Object {

/**
  *
  * Die Klasse bill stellt einen float amount mit der Gesamtsumme und eine Methode zum Berechnen und Ausgeben der Rechnung zur Verfgung
  * Die Methode printBill bentigt 3 Parameter: Pfad und Dateiname der Rechnungstabelle, sowie ein Objekt der
  * zugrundeliegenden Stammdatentabelle.
  *
  */

	bill() {
		// Ein leerer Construcotor
	}
	bill(String pfad, String name, articleDB Stammdaten){
		// Hier wird die Rechnung gleich berechent und ausgegeben
        	printBill(pfad, name, Stammdaten);
	}

	public static int amount;
	// Positionen mit denen gerechnet wird:
	public static int positionid[] = new int[10];
	public static int positionquantity[] = new int[10];
	public static int positionsinglevalue[] = new int[10];
	public static int positionvalue[] = new int[10];

	public static void printBill(String pfad, String name, articleDB Stammdaten){
                int i = 0;
                int j = 0;
                int hilf = 0;
                // record ist eine Zeile der Tabelle, ReadFile ist die Klasse aus der Angaben
		// und comma1 ist der Feldtrenner.
  		String record;
		ReadFile filehandle;
		int comma1;

		boolean found;
		boolean error = false;
		filehandle = new ReadFile(pfad,name);
		System.out.println("\nRechnung: " + name + "\n");
		amount = 0;
		while  (null != (record = filehandle.readLine()))  { // Eine Zeile wird eingelesen, und geprft, ob dort Daten drinstehen
			if (j==10) {
			 	System.out.println("Zuviele Artikel auf der Rechnung (>10): "+j);
				error = true;
				break;
			}
  			comma1 = record.indexOf(',');
			if (comma1 == -1) {
				System.out.println("Falsches Format: " + record);
				error = true;
				continue;
			}
			try {		// Die NumberFormatException tritt auf, wenn Buchstaben oder Sonderzeichen im String sind.
				positionid[j] = Integer.parseInt(record.substring(0,comma1));
			} catch (NumberFormatException e) {
				System.out.println("Illegales Zeichen in Artikelnummer: "+ record.substring(0,comma1));
				error = true;
				continue;
			}
			try {
				positionquantity[j] = Integer.parseInt(record.substring(comma1+1,record.length()));
			} catch (NumberFormatException e) {
				System.out.println("Illegales Zeichen in Artikelmenge: "+ record.substring(comma1 +1,record.length()));
				error = true;
				continue;
			}
			found = false;
			// Die ArtikelID wird in den Stammdaten gesucht. Der Suchalgorithmus ist natrlich nicht optimal, bei
			// 30 Elementen drfte es aber noch keine Laufzeitprobleme geben.
			for(i=0;i < Stammdaten.Artikelnummer.length  ;i++) {
				if (Stammdaten.Artikelnummer[i] == positionid[j]) {
					positionsinglevalue[j] = Stammdaten.Artikelpreis[i];
					positionvalue[j] = positionquantity[j] * positionsinglevalue[j];
					i = Stammdaten.Artikelnummer.length;
					found = true;
					
				}
			}
			if (found == false) {
				System.out.println("Der Artikel " + positionid[j] + " ist nicht in der Datenbank.");			
				error = true;
			}
			j++;
		}
		// Waren die Daten im korrekten Format sind, wird die Rechnung ausgegeben.
		// Nachdem die Berechnungen mit floats zu ungenau waren, habe ich alles mit Strings und Ints gemacht.
		if (error == false) {
			for(j=0;j < 10;j++) {
				if (positionid[j] < 1)
					break;
				amount = amount + positionvalue[j];				
				System.out.println((j+1) +" ID: "+ positionid[j] +" Menge: "+ positionquantity[j]
					+ " Einzelpreis: " + Integer.toString(positionsinglevalue[j]).substring(0,Integer.toString(positionsinglevalue[j]).length() - 2)
					+ "."+Integer.toString(positionsinglevalue[j]).substring(Integer.toString(positionsinglevalue[j]).length() - 2,Integer.toString(positionsinglevalue[j]).length())
					+ " Posten: " + Integer.toString(positionvalue[j]).substring(0,Integer.toString(positionvalue[j]).length() - 2)
					+ "."+Integer.toString(positionvalue[j]).substring(Integer.toString(positionvalue[j]).length() - 2,Integer.toString(positionvalue[j]).length()) );
			}
			System.out.println("\nGesamtbetrag: " + Integer.toString(amount).substring(0,Integer.toString(amount).length() - 2)
				+ "."+Integer.toString(amount).substring(Integer.toString(amount).length() - 2,Integer.toString(amount).length()) );
		}
	}
	
	public static void main(String args) {
	}
}